Index: trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/metadata/tsar_xbar_cluster.sd
===================================================================
--- trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/metadata/tsar_xbar_cluster.sd	(revision 475)
+++ trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/metadata/tsar_xbar_cluster.sd	(revision 547)
@@ -4,7 +4,7 @@
 Module('caba:tsar_xbar_cluster', 
     classname = 'soclib::caba::TsarXbarCluster',
-	tmpl_parameters = [
-		parameter.Int('dspin_cmd_width'),
-		parameter.Int('dspin_rsp_width'),
+   tmpl_parameters = [
+      parameter.Int('dspin_cmd_width'),
+      parameter.Int('dspin_rsp_width'),
         parameter.Module('vci_param_int', default = 'caba:vci_param',
                           cell_size = parameter.Reference('vci_data_width_int')),
@@ -13,16 +13,16 @@
         ],
 
-	header_files = [ '../source/include/tsar_xbar_cluster.h', 
+   header_files = [ '../source/include/tsar_xbar_cluster.h', 
         ],
 
-	implementation_files = [ '../source/src/tsar_xbar_cluster.cpp', 
+   implementation_files = [ '../source/src/tsar_xbar_cluster.cpp', 
         ],
 
-	uses = [
-		Uses('caba:base_module'),
-		Uses('common:mapping_table'),
-		Uses('common:iss2'),
+   uses = [
+      Uses('caba:base_module'),
+      Uses('common:mapping_table'),
+      Uses('common:iss2'),
               
-		Uses('caba:vci_cc_vcache_wrapper', 
+      Uses('caba:vci_cc_vcache_wrapper', 
               cell_size       = parameter.Reference('vci_data_width_int'),
               dspin_in_width  = parameter.Reference('dspin_cmd_width'),
@@ -31,5 +31,5 @@
               gdb_iss_t       = 'common:mips32el'),
 
-		Uses('caba:vci_mem_cache',
+      Uses('caba:vci_mem_cache',
               memc_cell_size_int = parameter.Reference('vci_data_width_int'),
               memc_cell_size_ext = parameter.Reference('vci_data_width_ext'),
@@ -37,64 +37,70 @@
               dspin_out_width = parameter.Reference('dspin_cmd_width')),
 
-		Uses('caba:vci_simple_rom',
+      Uses('caba:vci_simple_rom',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-		Uses('caba:vci_simple_ram',
+      Uses('caba:vci_simple_ram',
               cell_size       = parameter.Reference('vci_data_width_ext')),
 
-        Uses('caba:vci_xicu',
+      Uses('caba:vci_simple_ram',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-        Uses('caba:dspin_local_crossbar', 
+      Uses('caba:vci_xicu',
+              cell_size       = parameter.Reference('vci_data_width_int')),
+
+      Uses('caba:dspin_local_crossbar', 
               flit_width      = parameter.Reference('dspin_cmd_width')),
 
-        Uses('caba:dspin_local_crossbar', 
+      Uses('caba:dspin_local_crossbar', 
               flit_width      = parameter.Reference('dspin_rsp_width')),
 
-        Uses('caba:virtual_dspin_router', 
+      Uses('caba:virtual_dspin_router', 
               flit_width      = parameter.Reference('dspin_cmd_width')),
 
-        Uses('caba:virtual_dspin_router', 
+      Uses('caba:virtual_dspin_router', 
               flit_width      = parameter.Reference('dspin_rsp_width')),
 
-        Uses('caba:vci_multi_tty',
+      Uses('caba:vci_multi_tty',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-        Uses('caba:vci_framebuffer',
+      Uses('caba:vci_framebuffer',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-        Uses('caba:vci_multi_nic',
+      Uses('caba:vci_multi_nic',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-        Uses('caba:vci_chbuf_dma',
+      Uses('caba:vci_chbuf_dma',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-		Uses('caba:vci_block_device_tsar',
+      Uses('caba:vci_block_device_tsar',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-		Uses('caba:vci_multi_dma',
+      Uses('caba:vci_multi_dma',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-        Uses('caba:vci_dspin_target_wrapper',
+      Uses('caba:vci_dspin_target_wrapper',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-        Uses('caba:vci_dspin_initiator_wrapper',
+      Uses('caba:vci_dspin_initiator_wrapper',
               cell_size       = parameter.Reference('vci_data_width_int')),
 
-		Uses('common:elf_file_loader'),
-		],
+      Uses('caba:vci_simhelper',
+              cell_size       = parameter.Reference('vci_data_width_int')),
 
-	ports = [
-		Port('caba:bit_in', 'p_resetn', auto = 'resetn'),
-		Port('caba:clock_in', 'p_clk', auto = 'clock'),
-		Port('caba:dspin_output', 'p_cmd_out', [4, 3], 
+      Uses('common:elf_file_loader'),
+      ],
+
+   ports = [
+      Port('caba:bit_in', 'p_resetn', auto = 'resetn'),
+      Port('caba:clock_in', 'p_clk', auto = 'clock'),
+      Port('caba:dspin_output', 'p_cmd_out', [4, 3], 
               dspin_data_size = parameter.Reference('dspin_cmd_width')),
-		Port('caba:dspin_input', 'p_cmd_in', [4, 3], 
+      Port('caba:dspin_input', 'p_cmd_in', [4, 3], 
               dspin_data_size = parameter.Reference('dspin_cmd_width')),
-		Port('caba:dspin_output', 'p_rsp_out', [4, 2], 
+      Port('caba:dspin_output', 'p_rsp_out', [4, 2], 
               dspin_data_size = parameter.Reference('dspin_rsp_width')), 
-		Port('caba:dspin_input', 'p_rsp_in', [4, 2], 
+      Port('caba:dspin_input', 'p_rsp_in', [4, 2], 
               dspin_data_size = parameter.Reference('dspin_rsp_width')),
-		],
+      ],
 )
 